<?PHP 

/**
 * Write an E-Mail
 * 2005-13-04
 * Version 0.1
 * http://learn.tfh-berlin.de - ogrimm@tfh-berlin.de
 */


    require_once("../config.php");
    require_once("./lib.php");	
    require_once("../lib/moodlelib.php");

 	$id = required_param('id', PARAM_INT); 		 		// course
	$sel = required_param('sel', PARAM_ALPHA);  		// recipients (All, all teachers, all students, group or single selection);	
	$iid = required_param('iid', PARAM_INT);  			// block instance id
	optional_param('dir', 'lastname', PARAM_ALPHAEXT);	// how to sort students
	
    if (! $course = get_record("course", "id", $id)) {
        error("Course ID is incorrect");
    }

    require_login($course->id);





	if (! checkpermissions($course->id,$sel, get_email_settings($course->id, $iid))) {
	   error(get_string("notavailable","email"));
	}

 
    add_to_log($course->id, "email", "composemail", "compose.php?id=$course->id&sel=$sel", "");

//	echo '<link href="./styles.php" rel="stylesheet" type="text/css">';
	print_header("$course->shortname: ".get_string($sel, "email"), "$course->fullname",
				 "<A HREF=../course/view.php?id=$course->id>$course->shortname</A> -> ".
				 get_string("link","email"), "", "", true, "&nbsp;", navmenu($course));


//	$db->debug = true;


	//-- Send mail to all course members, both students and teachers
	//--------------------------------------------------------------
	if($sel == "all") {
		// -- display teacher's names
		if ($teachers = get_course_teachers($course->id, $dir)) {
			$rec_teachers = get_full_user_names($teachers, $course);
		}
		// -- display student's names
	  	// Get all students of a given course  
		$students = get_course_students($course->id,$dir);
		// Get count over all students of a given course
		$totalcount = count_course_students($course, "", "", "", $currentgroup);
		if ($totalcount == 0) {
			$rec_students = get_string("nostudentsfound", "", $course->students);
		}
		else {
			$rec_students = get_full_user_names($students, $course);
		}
		
	//-- Send mail to all course teachers
	//--------------------------------------------------------------		
	} else if($sel == "allteachers") {
		// display teacher's names
		if ($teachers = get_course_teachers($course->id, $dir)) {
			$rec_teachers = get_full_user_names($teachers, $course);
		}
	//-- Send mail to all course students 
	//--------------------------------------------------------------				
	} else if($sel == "allstudents") {
		// -- display student's names
	  	// Get all students of a given course  
		$students = get_course_students($course->id,$dir);
		// Get count over all students of a given course
		$totalcount = count_course_students($course, "", "", "", $currentgroup);
		if ($totalcount == 0) {
			// old: $rec_students = get_string("nostudentsfound", "", $course->students);
			error(get_string("nostudentsfound", "", $course->students),$CFG->wwwroot."/course/view.php?id=".$course->id);
			print_footer($course);
			exit;		
		}
		else {
			$rec_students = get_full_user_names($students, $course);
		}
		
	//-- Send mail to course groups
	//--------------------------------------------------------------	
	} else if($sel == "group") {
		$rec_groups = get_group_selection(get_groups($course->id));

        //if no groups available; print error and terminate script
		if($rec_groups == null){
			error(get_string("nogroups","email"),$CFG->wwwroot."/course/view.php?id=".$course->id);
			print_footer($course);
			exit;		
		}

		

	//-- Send mail to single selected course students 
	//--------------------------------------------------------------			
	} else if($sel == "select") {
		// -- display teacher's names
		if ($teachers = get_course_teachers($course->id, $dir)) {
			$rec_teachers = get_full_user_names_selection($teachers, $course);
		}
		
		// -- display student's names
	  	// Get all students of a given course  
		$students = get_course_students($course->id,$dir);
		// Get count over all students of a given course
		$totalcount = count_course_students($course, "", "", "", $currentgroup);
		if ($totalcount == 0) {
			$rec_students = get_string("nostudentsfound", "", $course->students);
		}
		else {
			$rec_students = get_full_user_names_selection($students, $course);
		}
		
	}
	// cancel if none of the above mentioned selection parameters is passed
	else { exit; }

?>

	<form action="./sendmail.php" method="post" enctype="multipart/form-data" name="sendmailform"> 
  	<input type="hidden" name="sel" value="<?php echo $sel; ?>">
  	<input type="hidden" name="id" value="<?php echo $id; ?>">
  	<input type="hidden" name="iid" value="<?php echo $iid; ?>">  	

	<h3><?php print_string($sel,"email"); ?></h3>
    <table  border="0" cellspacing="0" cellpadding="0"> 
<?php // Course teachers as recipients
      if(!empty($rec_teachers)) { ?>
      <tr align="left" valign="top"> 
        <td width="100"><span class="emphasis"><?php echo $course->teachers; ?>:</span> </td> 
        <td width="20">&nbsp;</td> 
        <td><?php echo $rec_teachers; ?></td> 
      </tr> 
      <tr align="left" valign="top"> 
        <td width="100">&nbsp;</td> 
        <td width="20">&nbsp;</td> 
        <td>&nbsp;</td> 
      </tr> 
<?php } // Students as recipients
       if(!empty($rec_students)){ ?>	  
      <tr align="left" valign="top"> 
        <td width="100"><span class="emphasis"><?php echo $course->students; ?>:</span> </td> 
        <td width="20">&nbsp;</td> 
        <td><?php echo $rec_students; ?></td> 
      </tr> 
      <tr align="left" valign="top"> 
        <td width="100">&nbsp;</td> 
        <td width="20">&nbsp;</td> 
        <td>&nbsp;</td> 
      </tr> 
<?php } // Course groups as recipients 
      if(!empty($rec_groups)){ ?>	  
      <tr align="left" valign="top"> 
        <td width="100"><span class="emphasis"><?php print_string("groups","moodle"); ?>:</span> </td> 
        <td width="20">&nbsp;</td> 
        <td><?php echo $rec_groups; ?></td> 
      </tr> 
      <tr align="left" valign="top"> 
        <td width="100">&nbsp;</td> 
        <td width="20">&nbsp;</td> 
        <td>&nbsp;</td> 
      </tr> 
<?php } ?>	

      <tr align="left" valign="top"> 
        <td width="100"><span class="emphasis"><?php print_string("sender", "email"); ?>:</span> </td> 
        <td width="20">&nbsp;</td> 
        <td><?php echo $USER->email; ?></td> 
      </tr> 
      <tr align="left" valign="top"> 
        <td width="100">&nbsp;</td> 
        <td width="20">&nbsp;</td> 
        <td>&nbsp;</td> 
      </tr> 	  
	  <tr align="left" valign="top">
        <td>&nbsp;</td>
        <td width="20">&nbsp;</td>
        <td>&nbsp;</td>
      </tr>
      <tr align="left" valign="top"> 
        <td width="100"><span class="emphasis"><?php print_string("subject","email"); ?>:</span> </td> 
        <td width="20">&nbsp;</td> 
        <td><input name="subject" type="text" class="mailform" size="95"></td> 
      </tr> 
      <tr align="left" valign="top"> 
        <td width="100">&nbsp;</td> 
        <td width="20">&nbsp;</td> 
        <td>&nbsp;</td> 
      </tr> 
      <tr align="left" valign="top"> 
        <td width="100"><span class="emphasis"><?php print_string("message","email"); ?>: </span></td> 
        <td width="20">&nbsp;</td> 
        <td>
			<!-- WYSIWYG-Editor ... -->
			<?php if(can_use_html_editor() && $USER->htmleditor) { 
					print_textarea(can_use_html_editor() , 20, 50, 680, 400, "message");
					use_html_editor();
				} else {?>
				<textarea name="message" cols="71" rows="10" class="mailform" id="message" wrap=\"virtual\"></textarea>
		<?php } ?>		</td> 
      </tr> 
      <tr align="left" valign="top"> 
        <td width="100">&nbsp;</td> 
        <td width="20">&nbsp;</td> 
        <td>&nbsp;</td> 
      </tr> 
      <tr align="left" valign="top"> 
        <td colspan="3"> <input name="sendcopy" type="checkbox" value="true" checked> 
          <?php print_string("sendcopy","email"); ?></td> 
      </tr> 
      <tr align="left" valign="top"> 
        <td width="100">&nbsp;</td> 
        <td width="20">&nbsp;</td> 
        <td>&nbsp;</td> 
      </tr> 
      <tr align="left" valign="top"> 
        <td width="100"><span class="emphasis"><?php print_string("attachment","email"); ?>:</span> </td> 
        <td width="20">&nbsp;</td> 
        <td> <input name="attachment" type="file" class="mailform"></td> 
      </tr> 
      <tr align="left" valign="top"> 
        <td width="100">&nbsp;</td> 
        <td width="20">&nbsp;</td> 
        <td>&nbsp;</td> 
      </tr> 
      <tr align="left" valign="top"> 
        <td width="100">&nbsp;</td> 
        <td width="20">&nbsp;</td> 
        <td><input name="cancel" type="reset" value="<?php print_string("cancel","email"); ?>" onclick="JavaScript: history.back();"> 
        <input name="sendmail" type="submit" value="<?php echo print_string("send","email"); ?>"></td> 
      </tr> 
</table> 
    <p>&nbsp;</p> 
    <p>&nbsp;</p> 
  </form> 

<?php print_footer($course); ?>
