<?PHP 
/**
 * Send an E-Mail
 * 2005-08-31
 * Version 0.2
 * http://learn.tfh-berlin.de - ogrimm@tfh-berlin.de
 */
 
    require_once("../config.php");
    require_once("./lib.php");
    require_once("../lib/datalib.php");
    require_once("../lib/phpmailer/class.phpmailer.php");
    require_once("../lib/phpmailer/language/phpmailer.lang-de.php");

 	$id = required_param('id', PARAM_INT); 		 		// course
	$sel = required_param('sel', PARAM_RAW);  			// recipients (All, all teachers, all students, group or single selection);	
	$iid = required_param('iid', PARAM_INT);  			// block instance id
	$sendcopy = optional_param('sendcopy', false,PARAM_BOOL); 	// Flag for sending or not sending a backupcopy to the sender 
	$subject = optional_param('subject','-', PARAM_CLEAN);  		// E-Mail subject
	$message = optional_param('message', PARAM_CLEANHTML);  		// E-Mail message


    if (! $course = get_record("course", "id", $id)) {
        error("Course ID is incorrect");
    }

    require_login($course->id);

	if (! checkpermissions($course->id,$sel, get_email_settings($course->id, $iid)) && !isadmin()) {
	   error(get_string("notavailable","email"));
	}


    // Container (array) to accumulate all necessary e-mail addresses
    $recipients = array();

    $sendername = fullname($USER, isteacher($course->id));

    if (! $course = get_record("course", "id", $id)) {
        error("Course ID is incorrect");
    }



    // till now recipients are logged in no way 
    // if you need the recipient's ids logged, just uncomment the lines at the bottom of this script
    add_to_log($course->id, "email", "sendmail", "sendmail.php?id=$course->id&sel=$sel", "");


	// Verify whether the uploaded file is correct - if not terminate this script
	if($_FILES['attachment']['name'] != "" && $_FILES['attachment']['size'] == 0 && !is_uploaded_file($_FILES['attachment']['tmp_name'])){
		echo "There's something wrong with the attached file...";
		exit;
	}

	print_header("$course->shortname: ".get_string($sel,"email"), "$course->fullname",
				 "<A HREF=../course/view.php?id=$course->id>$course->shortname</A> -> ".
				 get_string("link","email"), "", "", true, "&nbsp;", navmenu($course));



	//-- Accumulate mail addresses from all course members, both students and teachers
	//---------------------------------------------------------------------------------	
	if($sel == "all") {
		// -- accumulate recipients (teachers)
		if ($teachers = get_course_teachers($course->id)) {
			foreach($teachers as $teacher) {
				array_push($recipients,$teacher);
			}	
		}
		// -- accumulate students as recipients
		if($students = get_course_students($course->id)) {
			foreach($students as $student) {
				array_push($recipients,$student);
			}				
		}
	//-- Accumulate mail addresses from all course teachers but no students
	//---------------------------------------------------------------------------------		
	} else if($sel == "allteachers") {
		if ($teachers = get_course_teachers($course->id)) {
			foreach($teachers as $teacher) {
				array_push($recipients,$teacher);
			}
		}		
	//-- Accumulate mail addresses from all course students but no teachers
	//---------------------------------------------------------------------------------			
	} else if($sel == "allstudents") {
		if($students = get_course_students($course->id)) {
			foreach($students as $student) {
				array_push($recipients,$student);
			}				
		}
	//-- Accumulate mail addresses from one or more selected course groups
	//---------------------------------------------------------------------------------			
	} else if($sel == "group") {
		$mailrecip = required_param('mailrecip', PARAM_RAW);		
		// Check wether there is at least one selected recipient
		if (count($mailrecip) > 0) {
			foreach($mailrecip as $groupid) {		
				$temparray = get_recipient_list_from_groupid($groupid);
				foreach($temparray as $rec)
					array_push($recipients,$rec);
			}
		}	
	
	//-- Accumulate mail addresses from one or more selected course members
	//---------------------------------------------------------------------------------			
	} else if($sel == "select") {
		$mailrecip = required_param('mailrecip', PARAM_RAW);
		// Check wether there is at least one selected recipient
		if (count($mailrecip) > 0) {
			foreach($mailrecip as $recipient) {
				array_push($recipients, get_recipient_list_from_id($recipient));
			}
		}

	// _____ FOR ADMINISTRATORS ONLY _____
	//-- Accumulate mail addresses
	//---------------------------------------------------------------------------------			
	} else if($sel == "admin_allusers" && isadmin()) {	
		// if ($users = get_site_users("u.lastname ASC")) {
		$site = get_site();
		if($users = get_course_users($site->id, "u.lastname ASC")){	
			foreach($users as $user) {
				array_push($recipients,$user);
			}
		}
	} else if($sel == "admin_allteachers" && isadmin()) {	
		if ($users = get_teachers_sitewide()) {
			foreach($users as $user) {
				array_push($recipients,$user);
			}
		}
	} else if($sel == "admin_allcoursecreators" && isadmin()) {	
		if ($users = get_creators()) {
			foreach($users as $user) {
				array_push($recipients,$user);
			}
		}
	} else if($sel == "admin_allstudents" && isadmin()) {	
		if ($users = get_students_sitewide()) {
			foreach($users as $user) {
				array_push($recipients,$user);
			}
		}
	}	// _____ END ADMINISTRATOR'S FUNCTIONS _____
	
	// ===> cancel if none of the above mentioned selection parameters is passed
	else { error("Error!");  }
	
	if($_FILES['attachment']['name'] != "" && $_FILES['attachment']['size'] == 0 && isset($_FILES['attachment']) && $_FILES['attachment']['error']) {
		// if a file upload error occured, print error message
		if($_FILES['attachment']['error'] == 'UPLOAD_ERR_INI_SIZE' || $_FILES['attachment']['error'] == 'UPLOAD_ERR_FORM_SIZE') {
			echo "<p>Attachment size too big. Please choose a smaller file and try again.</p>";
		} else if($_FILES['attachment']['error'] == 'UPLOAD_ERR_PARTIAL') {
			echo "<p>".get_string("attachmenterror","email")."</p>";
		}
		echo "<p><a href=\"Javascript:history.back();\"> Go back </a><p>";
		exit;
	}

	// Now if there's any recipient, let's construct some e-mail messages
	//--------------------------------------------------------------------------------
	if(count($recipients) > 0) {

		$mail = new PHPMailer();
		$mail->SetLanguage($USER->lang);		           // "../lib/phpmailer/language/");
	        $mail->PluginDir = "$CFG->libdir/phpmailer/";      // plugin directory (eg smtp plugin)	
	
		// detect what kind of mail-function should be used	
		if ($CFG->smtphosts == "qmail") {
			$mail->IsQmail();                              // use Qmail system

		} else if (empty($CFG->smtphosts)) {			
		        $mail->IsMail();                              	   // use PHP mail() = sendmail

		} else {
			$mail->IsSMTP();                               // use SMTP directly
			if ($CFG->debug > 7) {
				echo "<pre>\n";
				$mail->SMTPDebug = true;
			}
			$mail->Host = "$CFG->smtphosts";               // specify main and backup servers
			$mail->SMTPKeepAlive = true;	
			if ($CFG->smtpuser) {                          // Use SMTP authentication
				$mail->SMTPAuth = true;
				$mail->Username = $CFG->smtpuser;		   // set SMTP-Username	
				$mail->Password = $CFG->smtppass;		   // set SMTP-Password 
			}
			else {
				$mail->SMTPAuth = false;    		       // turn off SMTP authentication
			}
		}
     	       
	    if (current_language() != "en") {
		 	$mail->CharSet = get_string("thischarset");
       }
 		
		// should a backup copy of the message be sent to the sender's address?
		if($sendcopy) {
			array_push($recipients,$USER);
		}
		
		//-- Set all necessary mail parameters
 		// Set the sender's name and mail address
		$mail->From = $USER->email;
		$mail->FromName = $sendername;
		// set the mail subject
		$mail->Subject = stripslashes($subject); 		
		// set word wrap to 79 characters 		
		$mail->WordWrap = 79;                                 

		// The following line is used to get rid of the incorrect backslashes inserted by the WYSIWYG-Editor.
		// Emoticons will now  be displayed...  A better solution will come soon, I hope!
		$message = stripslashes($message);
		// prepare message as a simple text
		$htmlmessage = text_to_html($message);
		// prepare message as a html-tagged message
		$textmessage = html_to_text($message);

		$srecipients = array();
		$frecipients = array();

		$mailcounter = 0;
		// Send a mail to every single recipient
		foreach($recipients as $recipient) {
			$mailcounter++;
			$mail->AddAddress($recipient->email);
			$mail->AddReplyTo($USER->email, fullname($USER, isteacher($course->id)));

			// add attachments if there are no problems
			if(isset($_FILES['attachment']) && !$_FILES['attachment']['error']) {
					$mail->AddAttachment($_FILES['attachment']['tmp_name'], $_FILES['attachment']['name']);
			}	

			//-- prepare the mail body in the favoured format (html or plain text)
			if($recipient->mailformat) {
				$mail->IsHTML(true);                            // set email format to HTML
		        $mail->Encoding = "quoted-printable";           // Encoding to use	
		        $mail->Body = $htmlmessage;
		        $mail->AltBody = $textmessage;
			} else {
				$mail->IsHTML(false);                            // set email format to plain text
		        $mail->Body = $textmessage;
				$mail->Encoding = "8bit";						// i'm not sure about this
				$mail->AltBody = null;
			}

			// attach recipients roster to backup-copy only
			if($recipient->email == $USER->email && $sendcopy) {
				// list succesful recpients 
				if(count($srecipients) > 0 )
					$mail->Body .= get_formated_recipients_list(get_string("recipientslist","email"),$srecipients,$USER->mailformat);
				// list failed recipients
				if(count($frecipients) > 0 )
					$mail->Body .= get_formated_recipients_list(get_string("faulty_recipientslist","email"),$frecipients,$USER->mailformat);				
			}

			// and no now, the most important thing: send out the mail
			if(!$mail->Send()) {
			// if(0){
			   // an error occured!!
			   echo "<span class=\"errorbox\"><br />".get_string("sendfailed","email")."<br />";
			   echo "Mailer Error: ".$mail->ErrorInfo."</span><br /><br />";
			   add_to_log($course->id, "email", "sendmail","sendmail.php?id=$course->id&sel=$sel" , "ERROR: $mail->ErrorInfo");
			   $recipient->errmsg = $mail->ErrorInfo;
			   array_push($frecipients, $recipient);
			}
			// okay, everything went fine ... :-)
			else {	
				echo "<br>$mailcounter. ".get_string("sentsuccessfully","email") . $recipient->lastname." ".$recipient->firstname; //.": ".$recipient->email;
				$recipient->errmsg = false;
			    array_push($srecipients, $recipient);
			}
			
			
			// clear all recipient specific mail paramters to be prepared for next round
			$mail->ClearAddresses();
			$mail->ClearAttachments();
			$mail->ClearReplyTos();
			$mail->ClearAllRecipients();
			$mail->ClearCustomHeaders();

		} // foreach-end
		
		//debug:
		//echo "<p>Anzahl der Empfaenger: ".count($recipients) ."</p>";
		
		if($mail->Mailer == "smtp") {
			$mail->SmtpClose();
		}
	} else {
			// Recipients Array seems to be empty, no need to send an email
			print_string("norecipients","email");
	}

	/*
	** 
	* Logging:
	* If youn need more detailed logging, just uncomment the following lines
	$recipients_log = "";
	foreach($recipients as $recip) {
		$recipients_log .= $recip->id . "; ";
	}
	// make a log entry containing all recipient's ids
	add_to_log($course->id, "email", "sendmail", "sendmail.php?id=$course->id&sel=$sel", "sender:".$USER->id." recipients: ".$recipients_log .":: MESSAGE :: ". $message);
	*
	*/
		
	echo "<p><a href=\"".$CFG->wwwroot."/course/view.php?id=".$id."\">";
	echo get_string("back2course","email")."</a></p>";
			
		
    print_footer($course);

?>
